<?php
/**
 * Print class
 */

if (!class_exists('WooCommerce_Gls_Envios_Print')) {

    class WooCommerce_Gls_Envios_Print
    {

        private $template_directory_name;
        private $template_path;
        private $template_default_path;
        private $template_default_uri;

        private $order;

        public $template_type;
        public $order_id;

        /**
         * Constructor
         */
        public function __construct()
        {
            global $woocommerce;
            //Dani a 16/09/2014 Desde la versión 2.2.2 de woocommerce la llamada hay que realizarla con un parámetro de entrada
            //$this->order = new WC_Order();
            if (!empty($order_id)) {
                $this->order = new WC_Order($order_id);
            } else {
                $this->order = new WC_Order();
            }
            $this->template_directory_name = 'print';
            $this->template_path = $woocommerce->template_url . $this->template_directory_name . '/';
            $this->template_default_path = WooCommerce_Gls_Envios::$plugin_path . 'templates/' . $this->template_directory_name . '/';
            $this->template_default_uri = WooCommerce_Gls_Envios::$plugin_url . 'templates/' . $this->template_directory_name . '/';
        }

        /**
         * Load the class
         */
        public function load()
        {
            add_action('admin_init', array($this, 'load_hooks'));
        }

        /**
         * Load the admin hooks
         */
        public function load_hooks()
        {
            add_action('wp_ajax_generate_gls_envio', array($this, 'generate_gls_envio_ajax'));
        }

        public function generate_gls_envio_ajax()
        {
            // Let the admin only access the page
            if (!is_admin()) {
                echo '<script>alert("generate_gls_envio_ajax: no es admin")</script>';
                wp_die(__('No tiene suficientes permisos para acceder a esta página.', 'woocommerce-gls-envios'));
            }
            // Check if all parameters are set
            if (empty($_GET['template_type']) || empty($_GET['order_id'])) {
                echo '<script>alert("generate_gls_envio_ajax: no están los parametros")</script>';
                wp_die(__('No tiene suficientes permisos para acceder a esta página.', 'woocommerce-gls-envios'));
            }

            // Generate the output
            //echo '<script>alert("generate_gls_envio_ajax: llamamos a generate_gls_envio")</script>';
            $this->generate_gls_envio($_GET['template_type'], (int) $_GET['order_id']);

            exit;
        }

        /**
         * Generate the template output
         */
        public function generate_gls_envio($template_type, $order_id, $mode = 1)
        {
            $codBarras = $this->existeEnvioGls($order_id);
            $sendAgain = isset($_GET['gls_sendagain']) && $_GET['gls_sendagain'] == 1 ? true : false;
			$openCarrier = get_option('gls_opencarrier');

			if (!empty($_GET['gls_service'])){
				$gls_servicio = $_GET['gls_service'];
			} else {
				$gls_servicio = $this->getServicio($order_id);
            }
			if (empty($gls_servicio) && $openCarrier){
				$gls_servicio = get_option(GLS_Settings::$prefix . 'default_service');
			}
			
			$glsValora = new WC_GLS_Shipping_Method();

            $guid = $glsValora->guid;
            $url = $glsValora->wsdl;
            $debug = "yes";
            //$debug = $glsValora->gls_debug;
            $bultos = $glsValora->bultos;

            $gls_order_status = $glsValora->order_status;

            //Dani a 02/01/2017
            if (isset($_GET['gls_incoterm_user'])) {
                $incoterm = $_GET['gls_incoterm_user'];
            } else {
                $incoterm = $glsValora->incoterm;
            }

            if ($bultos == '') {
                $bultos = 1;
            }

            if (!empty($_GET['gls_bultos_user'])) {
                $bultos = $_GET['gls_bultos_user'];
            }
            $retorno = 0;
            if (!empty($_GET['gls_retorno'])) {
                $retorno = $_GET['gls_retorno'];
            } else {
                $retorno = $glsValora->retorno;
            }
            $valorAsegurado = false;
            if (!empty($_GET['gls_valor_asegurado'])) {
                $valorAsegurado = $_GET['gls_valor_asegurado'];
            } else {
                $valorAsegurado = $glsValora->valor_asegurado;
            }
            $departamento = false;
            if (!empty($_GET['gls_departamento'])) {
                $departamento = $_GET['gls_departamento'];
            } else {
                $departamento = $glsValora->departamento;
            }
            $observacionesEnvio = false;
            if (!empty($_GET['gls_observaciones'])) {
                $observacionesEnvio = $_GET['gls_observaciones'];
            }
            $rcs = '';
            if (!empty($_GET['gls_rcs'])) {
                $rcs = $_GET['gls_rcs'];
            } else {
                $rcs = $glsValora->rcs;
            }
            $nombreRemitente = $glsValora->nombre_origen;
            $direccionRemitente = $glsValora->direccion_origen;
            $poblacionRemitente = $glsValora->poblacion_origen;
            $cpRemitente = $glsValora->source_zip;
            $etiqueta = $glsValora->etiqueta;

            if ($template_type == 'etiqueta') {
                if ((int)$codBarras == 0 || (empty($_REQUEST['doaction']) && $sendAgain)) {
                    $order = wc_get_order($order_id);
                    $order_status = $order->get_status();
                    $this->graba($order_id, $guid, $url, $bultos, $retorno, $rcs, $valorAsegurado, $departamento, $observacionesEnvio, $nombreRemitente, $direccionRemitente, $poblacionRemitente, $cpRemitente, $debug, $incoterm, $gls_order_status, $mode, $codBarras);
                    /*
                    if ('processing' == $order_status) {
                        $this->graba($order_id, $guid, $url, $bultos, $retorno, $rcs, $valorAsegurado, $departamento, $observacionesEnvio, $nombreRemitente, $direccionRemitente, $poblacionRemitente, $cpRemitente, $debug, $incoterm, $gls_order_status, $mode);
                    } else {

                    }
                    */
                } else {
                    if ($mode == 1) {
                        $this->etiqueta($codBarras, $order_id, $guid, $url, $etiqueta, $debug);
                    }

                }
            } else {
                if ($codBarras == 0) {
                    echo __('No existe el tracking, parece que no se ha enviado a GLS', 'woocommerce-gls-envios');
                } else {
                    $this->tracking($codBarras, $order_id, $guid, $url, $debug);
                }
            }
        }

        public function tracking($codBarras, $order_id, $guid, $url, $debug)
        {
            //echo '<script>alert("entro en tracking")</script>';
            $gls_servicio = $this->getServicio($order_id);
          
            $order = wc_get_order($order_id);
            $cpDst = $order->get_shipping_postcode();
            $enlace = $enlaceJavascript = preg_replace(
                array('/\{tracking_number\}/', '/\{postal_code\}/'),
                array($codBarras, $cpDst),
                GLS_Settings::$tracking_url
            );

            if ($debug == "yes") {
                $mensaje = 'Consulta tracking: ' . $enlace;
				error_log("\r\n[" . date("r") . "] " . $mensaje, 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
            }

            header('Location: ' . $enlace);
        }

        public function etiqueta($codBarras, $order_id, $guid, $url, $etiqueta, $debug)
        {
            if (!class_exists('FPDF')) {
                require_once 'fpdf.php';
                require_once 'fpdi/fpdi.php';
            }

            $XML = '<?xml version="1.0" encoding="utf-8"?>
                    <soap12:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap12="http://www.w3.org/2003/05/soap-envelope">
                      <soap12:Body>
                          <EtiquetaEnvio xmlns="http://www.asmred.com/">
                              <codigo>' . $codBarras . '</codigo>
                              <tipoEtiqueta>' . $etiqueta . '</tipoEtiqueta>
                          </EtiquetaEnvio>
                        </soap12:Body>
                    </soap12:Envelope>';

            if ($debug == "yes") {
                $mensaje = 'Consulta etiqueta: ' . $XML;
				error_log("\r\n[" . date("r") . "] " . $mensaje, 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
            }

            $ch = curl_init();

            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_HEADER, false);
            curl_setopt($ch, CURLOPT_FORBID_REUSE, true);
            curl_setopt($ch, CURLOPT_FRESH_CONNECT, true);
            curl_setopt($ch, CURLOPT_URL, "https://www.asmred.com/websrvs/printserver.asmx");
            curl_setopt($ch, CURLOPT_POSTFIELDS, $XML);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: text/xml; charset=UTF-8"));

            $postResult = curl_exec($ch);

            if ($debug == "yes") {
                $startTag = strpos($postResult, '<Etiquetas>') + 11;
                $lengthTag = strpos($postResult, '</Etiquetas>') - $startTag;
                $noTagResult = substr_replace($postResult, '_ETIQUETA_', $startTag, $lengthTag);

                $mensaje = 'Respuesta etiqueta: ' . $noTagResult;
				error_log("\r\n[" . date("r") . "] " . $mensaje, 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
            }

            $result = strpos($postResult, '<base64Binary>');
            if ($result !== false) {
                //Encontrado (quitamos todo el código pdf)
                $cadena1 = substr($postResult, 0, $result + 14);
                $result2 = strpos($postResult, '</base64Binary>');
                $cadena2 = substr($postResult, $result2);
            } else {
                //No encontrado
                return false;
            }

            if (curl_errno($ch)) {
            }
            $xml = simplexml_load_string($postResult, null, 0, "http://www.w3.org/2003/05/soap-envelope");
            if ($xml === false) {
                return;
            }
            $xml->registerXPathNamespace("asm", "http://www.asmred.com/");
            $arr = $xml->xpath("//asm:EtiquetaEnvioResponse/asm:EtiquetaEnvioResult/asm:base64Binary");
            $gls_etiqueta = base64_decode($arr[0]);

            $dir = plugin_dir_path(__FILE__);

            if ($etiqueta == 'PDF') {
                file_put_contents($dir . 'gls_etiqueta.pdf', $gls_etiqueta);
                $pdf = new FPDI();
                $npages = $pdf->setSourceFile($dir . 'gls_etiqueta.pdf');
				$pdfcount = ((!empty($_GET['section']))?(int)$_GET['section']:0) - 1;
                for ($i = 1; $i <= $npages; $i++) {
                   
                    $templateId = $pdf->importPage($i);
                    $size = $pdf->getTemplateSize($templateId);
                    $orientation = ($size['h'] > $size['w']) ? 'P' : 'L';
                    $posx = 0;
                    $posy = 0;
                    $glsOptions = get_option('gls_envios_options');
                    if ((int)$glsOptions[GLS_Settings::$prefix . 'apli4'] != 1) {
                        // Consecutive labels
						$pdf->AddPage($orientation, array($size['w'], $size['h']));
                        $pdf->useTemplate($templateId, $posx, $posy, $size['w'], $size['h']);
                    } else { 
						if ($i == 1 || $pdfcount == 0){
							$pdf->AddPage($orientation, array($size['w']*2, $size['h']*2));					
						}
                        // Appli 4 labels
                        switch ($pdfcount) {
                            case 0:
                                $posx = 0;
                                $posy = 0;                                
                                $pdfcount++;
                                break;
                            case 1:
                                $posx = $size['w'];
                                $posy = 0;
                                $pdfcount++;
                                break;
                            case 2:
                                $posx = 0;
                                $posy = $size['h'];
                                $pdfcount++;
                                break;
                            case 3:
                                $posx = $size['w'];
                                $posy = $size['h'];
                                $pdfcount = 0;	
                                break;
                        }                        
                        $pdf->useTemplate($templateId, $posx, $posy, $size['w'], $size['h']);
                    }                        
                }                
               // if (version_compare(FPDF_VERSION, '1.8') >= 0 && !function_exists('cex_option_page')) {
                    $pdf->Output('D', 'etiqueta.pdf');
                /* } else {
                    $pdf->Output('etiqueta.pdf', 'D');
                } */
                unlink($dir . 'gls_etiqueta.pdf');
            } else {
                $length = strlen($gls_etiqueta);

                header('Content-Description: File Transfer');
                header('Content-Type: text/plain');
                header('Content-Disposition: attachment; filename=etiqueta.txt');
                header('Content-Transfer-Encoding: binary');
                header('Content-Length: ' . $length);
                header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                header('Expires: 0');
                header('Pragma: public');

                echo $gls_etiqueta;
            }
        }

        public function multietiquetas($orderids)
        {
            global $wpdb;
            if (!class_exists('FPDF')) {
                require_once 'fpdf.php';
                require_once 'fpdi/fpdi.php';
            }
            $pdf = new FPDI();
            $isPDF = false;
            $epl = '';
            $pdfcount = 0;
            foreach ($orderids as $orderid) {
                $order = wc_get_order($orderid);
                $codBarras = $order->get_meta('codbarras');
                if (empty($codBarras)) {
                    continue;
                }

                $gls_servicio = $this->getServicio($orderid);
                $glsValora = new WC_GLS_Shipping_Method();
                $etiqueta = $glsValora->etiqueta;

                $XML = '<?xml version="1.0" encoding="utf-8"?>
						<soap12:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap12="http://www.w3.org/2003/05/soap-envelope">
						  <soap12:Body>
							  <EtiquetaEnvio xmlns="http://www.asmred.com/">
								  <codigo>' . $codBarras . '</codigo>
								  <tipoEtiqueta>' . $etiqueta . '</tipoEtiqueta>
							  </EtiquetaEnvio>
							</soap12:Body>
						</soap12:Envelope>';

                $ch = curl_init();

                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
                curl_setopt($ch, CURLOPT_HEADER, false);
                curl_setopt($ch, CURLOPT_FORBID_REUSE, true);
                curl_setopt($ch, CURLOPT_FRESH_CONNECT, true);
                curl_setopt($ch, CURLOPT_URL, "https://www.asmred.com/websrvs/printserver.asmx");
                curl_setopt($ch, CURLOPT_POSTFIELDS, $XML);
                curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: text/xml; charset=UTF-8"));

                $postResult = curl_exec($ch);

                $result = strpos($postResult, '<base64Binary>');
                if ($result !== false) {
                    //Encontrado (quitamos todo el c�digo pdf)
                    $cadena1 = substr($postResult, 0, $result + 14);
                    $result2 = strpos($postResult, '</base64Binary>');
                    $cadena2 = substr($postResult, $result2);
                } else {
                    //No encontrado
                }

                if (curl_errno($ch)) {
                }
                $xml = simplexml_load_string($postResult, null, 0, "http://www.w3.org/2003/05/soap-envelope");
                if ($xml === false) {
                    return;
                }
                $xml->registerXPathNamespace("asm", "http://www.asmred.com/");
                $arr = $xml->xpath("//asm:EtiquetaEnvioResponse/asm:EtiquetaEnvioResult/asm:base64Binary");
                $gls_etiqueta = base64_decode($arr[0]);
                if (empty($gls_etiqueta)) {
                    continue;
                }

                $dir = plugin_dir_path(__FILE__);

                if ($etiqueta == 'PDF') {
                    $isPDF = true;
                    file_put_contents($dir . 'gls_etiqueta' . $orderid . '.pdf', $gls_etiqueta);
                    $npages = $pdf->setSourceFile($dir . 'gls_etiqueta' . $orderid . '.pdf');                    
                    for ($i = 1; $i <= $npages; $i++) {
                        $templateId = $pdf->importPage($i);
                        $size = $pdf->getTemplateSize($templateId);
                        $orientation = ($size['h'] > $size['w']) ? 'P' : 'L';
                        $posx = 0;
					    $posy = 0;
                        $glsOptions = get_option('gls_envios_options');
                        if ((int)$glsOptions[GLS_Settings::$prefix . 'apli4'] != 1) {
                            // Consecutive labels
                            $pdf->AddPage($orientation, array($size['w'], $size['h']));
                            $pdf->useTemplate($templateId, $posx, $posy, $size['w'], $size['h']);
                        } else {
                            // Appli 4 labels
                            switch ($pdfcount) {
                                case 0:
                                    $posx = 0;
                                    $posy = 0;
                                    $pdf->AddPage($orientation, array($size['w']*2, $size['h']*2));
                                    $pdfcount++;
                                    break;
                                case 1:
                                    $posx = $size['w'];
                                    $posy = 0;
                                    $pdfcount++;
                                    break;
                                case 2:
                                    $posx = 0;
                                    $posy = $size['h'];
                                    $pdfcount++;
                                    break;
                                case 3:
                                    $posx = $size['w'];
                                    $posy = $size['h'];
                                    $pdfcount = 0;	
                                    break;
                            }
                            $pdf->useTemplate($templateId, $posx, $posy, $size['w'], $size['h']);
                        }                        
                    }
                    unlink($dir . 'gls_etiqueta' . $orderid . '.pdf');
                } else {
                    $epl .= $gls_etiqueta;
                }
            }
            if ($isPDF) {
				error_log("\r\n[" . date("r") . "] FPDF_VERSION " . version_compare(FPDF_VERSION, '1.8'), 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");

                    $pdf->Output('D', 'etiqueta.pdf');
                if (version_compare(FPDF_VERSION, '1.8') >= 0) {
                } else {
                    $pdf->Output('etiqueta.pdf', 'D');
                }
            } else {
                ob_clean();
                $length = strlen($epl);

                header('Content-Description: File Transfer');
                header('Content-Type: text/plain');
                header('Content-Disposition: attachment; filename=etiqueta.txt');
                header('Content-Transfer-Encoding: binary');
                header('Content-Length: ' . $length);
                header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                header('Expires: 0');
                header('Pragma: public');

                echo $epl;
                die;
            }
        }

        public function graba($order_id, $guid, $url, $bultos, $retorno, $rcs, $valorAsegurado, $departamento, $observacionesEnvio, $nombreRemitente, $direccionRemitente, $poblacionRemitente, $cpRemitente, $debug, $incoterm, $gls_order_status, $mode, $cod_barras = null)
        {
			$debug = 'yes';
            global $woocommerce;
            $this->order = wc_get_order($order_id);
            $items = $this->order->get_items();
            $data_list = array();
			$glsOptions = get_option('gls_envios_options');
			if (!empty($glsOptions['gls_weight'])){
				$peso = (float)($glsOptions['gls_weight']);
			} else {
				$peso = 0;
				if (sizeof($items) > 0) {
					foreach ($items as $item) {
						if ($item['qty'] > 0) {
							//$product = $this->order->get_product_from_item( $item );
							$productId = (!empty($item['variation_id'])) ? $item['variation_id'] : $item['product_id'];
							$product = wc_get_product($productId);
							$weight = $product->get_weight();
							$i = 2;
							while ( metadata_exists( 'post', $productId, '_weight'.$i ) ) {
								$extraWeight = get_post_meta( $productId, '_weight'.$i, true );
								$weight += $extraWeight;
								$i++;
							}
							$peso += intval( $weight ) * $item['qty'];
						}
					}
				}
				
				$weight_unit = get_option('woocommerce_weight_unit');
				$weight_unit = apply_filters('sod_wc_gls_weight_unit', $weight_unit);

				switch ($weight_unit) {
					case "g":
						$peso = $peso / 1000;
						break;
					case "kg":
						$peso = $peso;
						break;
					case "lbs":
						$peso = number_format($peso * 0.45359237, 2);
						break;
					case "oz":
						$peso = $peso / 16;
						break;
					default:
						break;
				}

			}
            $gls_reembolso = 0;

            $paymentMethod = $this->order->get_meta( '_payment_method' );
            if ($paymentMethod == 'cod') {
                $gls_reembolso = $this->order->get_total();
            }

            $gls_nombre_remitente = $nombreRemitente;
            $gls_nombre_via_remitente = $direccionRemitente;
            $gls_poblacion_remitente = $poblacionRemitente;
            $gls_CP_remitente = $cpRemitente;

            $base_country = get_option('woocommerce_default_country');
            if (strlen($base_country) > 2) {
                $country_code = explode(":", $base_country);
            } else {
                $country_code[0] = $base_country;
            }
            $base_country_code = $country_code[0];
            $codPaises = GLS_Settings::$country_codes;

            $gls_pais_remitente = $codPaises[$base_country_code];

			$openCarrier = get_option('gls_opencarrier');

			if (!empty($_GET['gls_service']) && empty($_REQUEST['doaction'])){
				$gls_servicio = $_GET['gls_service'];
			} else {
				$gls_servicio = $this->getServicio($order_id);
            }
			if (empty($gls_servicio) && $openCarrier){
				$gls_servicio = $glsOptions[GLS_Settings::$prefix . 'default_service'];
			}

            $glsValora = new WC_GLS_Shipping_Method();
            $etiqueta = $glsValora->etiqueta;

            if ($gls_servicio == 'gls10') {
                $servicio = 1;
                $horario = 0;
            } elseif ($gls_servicio == 'gls14') {
                $servicio = 1;
                $horario = 2;
            } else if ($gls_servicio == 'gls24') {
                $servicio = 1;
                $horario = 3;
            } else if ($gls_servicio == 'buspar') {
                $servicio = 96;
                $horario = 18;
            } else if ($gls_servicio == 'economy') {
                $servicio = 37;
                $horario = 18;
            } else if ($gls_servicio == 'eurobusinessparcel') {
                $servicio = 74;
                $horario = 3;
            } else if ($gls_servicio == 'parcelshopgls') {
                $servicio = 1;
                $horario = 19;
            } else if ($gls_servicio == 'shopdelint') {
                $servicio = 74;
                $horario = 19;
            }
            //Dani 02/01/2016
            if ($peso == 0) {
                $peso = 1;
            }

            //Dani 02/01/2017 Si el servicio es EBP y el peso es inferior a 3, entonces lo cambio a SEBP
            if ($servicio == 74 && $peso < 3) {
                $servicio = 76;
            }
			$order = wc_get_order( $order_id );
			$firstname = $order->get_shipping_first_name();
			$lastname = $order->get_shipping_last_name();
			$address_1 = $order->get_shipping_address_1();
			$address_2 = $order->get_shipping_address_2();
			
            $gls_nombre_destinatario = $firstname.' '.$lastname;
            $gls_nombre_via_destinatario = $address_1.' '.$address_2;
            $gls_poblacion_destinatario = $order->get_shipping_city();
            $gls_pais = $order->get_shipping_country();
            $gls_CP_destinatario = $order->get_shipping_postcode();
            $gls_telefono_destinatario = $order->get_shipping_phone();
            $gls_email_destinatario = $order->get_billing_email();
            $gls_referencia = $this->getReferenciaDst($order_id);
            $gls_observaciones = $this->getObservaciones($order_id);

            if ($gls_servicio == 'parcelshopgls' || $gls_servicio == 'shopdelint') {
                $parcels = $this->getParcel($order_id);
            } else {
                $parcels = false;
            }

            if (!empty($observacionesEnvio)) {
                $gls_observaciones = $observacionesEnvio;
            }
            $retorno = ($retorno == 'No') ? 0 : $retorno;

            $vsecdata = '';
            if (!empty($valorAsegurado)) {
                $vsecdata = "\n                      <Seguro tipo=\"1\">
                        <Descripcion></Descripcion>
                        <Importe>" . $valorAsegurado . "</Importe>
                      </Seguro>";
            }
            if (!empty($departamento)) {
                $depdata = "\n                      <Departamento><![CDATA[" . (substr($departamento, 0, 50)) . "]]></Departamento>";
            }

            $rcsdata = '';
            if ($rcs != '' && $rcs != 'No' && !in_array($servicio,array(74,76))) {
                $rcsdata = "\n                    <Pod>" . (substr($rcs, 0, 1)) . "</Pod>\n";
            }

            $xml =
                '<?xml version="1.0" encoding="utf-8"?>
                <soap12:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap12="http://www.w3.org/2003/05/soap-envelope">
                  <soap12:Body>
                    <GrabaServicios  xmlns="http://www.asmred.com/">
                      <docIn>
                <Servicios uidcliente="' . $guid . '">
                  <Envio' . (empty($cod_barras) ? '' : ' action="delete_insert" codigoAnular="' . $cod_barras . '"') . '>
				  ' . ((($servicio != 74 && $servicio != 76) && !empty($rcsdata)) ? $rcsdata : '') . '
                    <Portes>P</Portes>
                    <Servicio>' . $servicio . '</Servicio>
                    <Horario>' . $horario . '</Horario>
                    <Bultos>' . $bultos . '</Bultos>';
			if ($servicio != 74 && $servicio != 76){
				$xml .= '<Retorno>' . $retorno . '</Retorno>';
			}
                $xml .=  '<Peso>' . $peso . '</Peso>';

            //Dani a EBP
            if (($servicio == 74 || $servicio == 76) && $incoterm > 0) {
                $xml .= '
                    <Aduanas><Incoterm>' . $incoterm . '</Incoterm></Aduanas>
                    ';
            }

            //if (($servicio != 74 && $servicio != 76) && $gls_reembolso != 0) {
            if ($gls_reembolso != 0) {
                $xml .= '<Importes><Reembolso>' . $gls_reembolso . '</Reembolso></Importes>';
            }

            $xml .= '
                    <Remite>
                      ' . ((!empty($depdata)) ? $depdata : '') . '
                      <Nombre><![CDATA[' . $gls_nombre_remitente . ']]></Nombre>
                      <Direccion><![CDATA[' . $gls_nombre_via_remitente . ']]></Direccion>
                      <Poblacion><![CDATA[' . $gls_poblacion_remitente . ']]></Poblacion>
                      <Pais>' . $gls_pais_remitente . '</Pais>
                      <CP>' . $gls_CP_remitente . '</CP>
                    </Remite>
                    <Destinatario>
                      <Nombre><![CDATA[' . $gls_nombre_destinatario . ']]></Nombre>';
            if (!empty($parcels)) {
                $xml .= '<Direccion><![CDATA[' . $parcels['direccion'] . ']]></Direccion>
                      <Poblacion><![CDATA[' . $parcels['localidad'] . ']]></Poblacion>
                      <Pais>' . $gls_pais . '</Pais>
                      <CP>' . $parcels['cp'] . '</CP>
                      <Telefono>' . $gls_telefono_destinatario . '</Telefono>
                      <Movil>' . $gls_telefono_destinatario . '</Movil>
                      <Observaciones><![CDATA[' . $parcels['nombre'] . "\n" . $gls_observaciones . ']]></Observaciones>
                      <Email>' . $gls_email_destinatario . '</Email>
					  <Codigo>' . $parcels['codigo'] . '</Codigo>';
            } else {
                $xml .= '<Direccion><![CDATA[' . $gls_nombre_via_destinatario . ']]></Direccion>
                      <Poblacion><![CDATA[' . $gls_poblacion_destinatario . ']]></Poblacion>
                      <Pais>' . $gls_pais . '</Pais>
                      <CP>' . $gls_CP_destinatario . '</CP>
                      <Telefono>' . $gls_telefono_destinatario . '</Telefono>
                      <Movil>' . $gls_telefono_destinatario . '</Movil>
                      <Observaciones>' . $gls_observaciones . '</Observaciones>
                      <Email>' . $gls_email_destinatario . '</Email>';
            }
            $xml .= '</Destinatario>
					' . ((!empty($vsecdata)) ? $vsecdata : '') . '
                    <Referencias>
                      <Referencia tipo="C">' . $gls_referencia . '</Referencia>
                    </Referencias>
					<DevuelveAdicionales>
						<Etiqueta tipo="' . $etiqueta . '"></Etiqueta>
					</DevuelveAdicionales>
                  </Envio>
                  <Plataforma>WooCommerce ' . $woocommerce->version . '</Plataforma>
                </Servicios></docIn>
                    </GrabaServicios>
                  </soap12:Body>
                </soap12:Envelope>';

            // Albert a 03/04/2017.
            // Como los clientes ya tienen en la Config. del m�dulo el http, forzamos aqu� el https para que no tengan que cambiarlo ellos.
            // Adem�s de toda la inclusi�n del https.
            //$xml = str_replace("http://", "https://", $xml);
            // Esto era un error. Si se cambia as� las urls se cambia tambi�n el schema del soap, lo cual falla.

            if ($debug == "yes") {
                $mensaje = 'Graba. XML: ' . $xml;
				error_log("\r\n[" . date("r") . "] " . $mensaje, 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
            }

            $plainxml = $xml;

            $ch = curl_init();
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_HEADER, false);
            curl_setopt($ch, CURLOPT_FORBID_REUSE, true);
            curl_setopt($ch, CURLOPT_FRESH_CONNECT, true);
            curl_setopt($ch, CURLOPT_URL, 'https://wsclientes.asmred.com/b2b.asmx');
            curl_setopt($ch, CURLOPT_POSTFIELDS, $xml);
            //curl_setopt($ch, CURLOPT_HTTPHEADER, Array("Content-Type: text/xml"));
            curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: text/xml; charset=UTF-8"));

            $postResult = curl_exec($ch);

            $startTag = strpos($postResult, '<Etiquetas>') + 11;
            $lengthTag = strpos($postResult, '</Etiquetas>') - $startTag;
			
            $noTagResult = $startTag > 11 ? substr_replace($postResult, '_ETIQUETA_', $startTag, $lengthTag) : $postResult;


            if ($debug == "yes") {
                $mensaje = 'Graba. Resultado: ' . $noTagResult;
                //$mensaje = 'Graba. Resultado: '.$postResult;
				error_log("\r\n[" . date("r") . "] " . $mensaje, 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
            }

            if (curl_errno($ch)) {
                //echo '<pre>' . print_r($plainxml,true) . '</pre>';
                if ($debug == "yes") {
                    $mensaje = 'Graba. Curl_errno: No se pudo llamar al ws de GLS';
					error_log("\r\n[" . date("r") . "] " . $mensaje, 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
                }
                wp_die('No se pudo llamar al ws de GLS: ' . $noTagResult);
            } else {
                $xml = simplexml_load_string($postResult, null, 0, "http://www.w3.org/2003/05/soap-envelope");
                if ($xml === false) {
                    echo 'Error al llamar al ws de GLS: ' . $noTagResult;
                    if ($debug == "yes") {
                        $mensaje = 'Graba. Curl_errno: Error al llamar al ws de GLS';
						error_log("\r\n[" . date("r") . "] " . $mensaje, 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
                    }
                    return;
                }
                $xml->registerXPathNamespace('asm', 'http://www.asmred.com/');
                $arr = $xml->xpath("//asm:GrabaServiciosResponse/asm:GrabaServiciosResult");
                $ret = $arr[0]->xpath("//Servicios/Envio");
                //return $ret[0];
                $return = $ret[0]->xpath("//Servicios/Envio/Resultado/@return");

                $referenciaN = $arr[0]->xpath('//Servicios/Envio/Referencias/Referencia[@tipo="N"]');
				if (is_array($referenciaN) && isset($referenciaN[0])) $referenciaN = (string)$referenciaN[0];
                if (!empty($return[0]) && $return[0] != '0') {
                    $error = $arr[0]->xpath("//Servicios/Envio/Errores/Error");
                    // echo '<pre>' . print_r($plainxml,true) . '</pre>';
                    if ($debug == "yes") {
                        $mensaje = 'Graba. Retorno webservice: No se pudo grabar en GLS. Retorno: ' . $return[0] . '. ' . $error[0];
						error_log("\r\n[" . date("r") . "] " . $mensaje, 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
                    }
					if (!is_array($error)){
						wp_die('No se pudo grabar en GLS. Retorno: ' . $return[0]);
					} else {
						wp_die('No se pudo grabar en GLS. Retorno: ' . $return[0] . '. ' . $error[0]);
					}
                } else {
                    $cb = $ret[0]->xpath("//Servicios/Envio/@codbarras");                    

                    if ($debug == "yes") {
                        $mensaje = 'Graba. Numero codigo barras = ' . $cb[0]["codbarras"];
						error_log("\r\n[" . date("r") . "] " . $mensaje, 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
                    }

                    $codBarras = $cb[0]["codbarras"];
                    if (!empty($codBarras)) {

						$order->update_meta_data( 'codbarras', (string)$codBarras );
						$order->update_meta_data( 'gls_bultos', $bultos );
						$order->update_meta_data( 'gls_retorno', $retorno );
						$order->update_meta_data( 'gls_rcs', $rcs );
						$order->update_meta_data( 'gls_departamento', $departamento );
						$order->update_meta_data( 'gls_valor_asegurado', $valorAsegurado );
						$order->update_meta_data( 'gls_estado', '0' );
						if (($servicio == 74 || $servicio == 76) && $incoterm > 0) {
							$order->update_meta_data( 'gls_incoterm', $incoterm );
						}
                        $glsOptions = get_option('gls_envios_options');
						$disableStateUpdate = $glsOptions['gls_disable_state_update'];
						$gls_order_state_sended = $glsOptions['gls_order_state_sended'];
						if (!$disableStateUpdate) $order->update_status($gls_order_state_sended);
						$note = gls_get_tracking_note($order_id);
						$noteType = gls_get_tracking_note_type();
						$order->add_order_note( $note ,$noteType);
                        $order->save();
                    }

                    if ($mode == 1) {
                        if (!class_exists('FPDF')) {
                            require_once 'fpdf.php';
                            require_once 'fpdi/fpdi.php';
                        }

                        $etiquetaSrc = $arr[0]->xpath('//Servicios/Envio/Etiquetas/Etiqueta')[0];
                        $gls_etiqueta = base64_decode($etiquetaSrc[0]);

                        $dir = plugin_dir_path(__FILE__);

                        if ($etiqueta == 'PDF') {
                            
							file_put_contents($dir . 'gls_etiqueta.pdf', $gls_etiqueta);
							$pdf = new FPDI();
							$npages = $pdf->setSourceFile($dir . 'gls_etiqueta.pdf');
							$pdfcount = 0;
							for ($i = 1; $i <= $npages; $i++) {
								$templateId = $pdf->importPage($i);
								$size = $pdf->getTemplateSize($templateId);
								$orientation = ($size['h'] > $size['w']) ? 'P' : 'L';
								$posx = 0;
								$posy = 0;
								if ((int)$glsOptions[GLS_Settings::$prefix . 'apli4'] != 1) {
									// Consecutive labels
									$pdf->AddPage($orientation, array($size['w'], $size['h']));
									$pdf->useTemplate($templateId, $posx, $posy, $size['w'], $size['h']);
								} else { 
									if ($i == 1 || $pdfcount == 0){
										$pdf->AddPage($orientation, array($size['w']*2, $size['h']*2));					
									}
									// Appli 4 labels
									switch ($pdfcount) {
										case 0:
											$posx = 0;
											$posy = 0;                                
											$pdfcount++;
											break;
										case 1:
											$posx = $size['w'];
											$posy = 0;
											$pdfcount++;
											break;
										case 2:
											$posx = 0;
											$posy = $size['h'];
											$pdfcount++;
											break;
										case 3:
											$posx = $size['w'];
											$posy = $size['h'];
											$pdfcount = 0;	
											break;
									}                        
									$pdf->useTemplate($templateId, $posx, $posy, $size['w'], $size['h']);
								}                        
							}                
							if (version_compare(FPDF_VERSION, '1.8') >= 0 && !function_exists('cex_option_page')) {
								$pdf->Output('D', 'etiqueta.pdf');
							} else {
								$pdf->Output('etiqueta.pdf', 'D');
							}
							unlink($dir . 'gls_etiqueta.pdf');
                        } else {
                            $length = strlen($gls_etiqueta);

                            header('Content-Description: File Transfer');
                            header('Content-Type: text/plain');
                            header('Content-Disposition: attachment; filename=etiqueta.txt');
                            header('Content-Transfer-Encoding: binary');
                            header('Content-Length: ' . $length);
                            header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                            header('Expires: 0');
                            header('Pragma: public');

                            echo $gls_etiqueta;
                        }
                    }
                }
            }
        }

        public function existeEnvioGls($order_id)
        {
            $order = wc_get_order($order_id);
            $codBarras = $order->get_meta('codbarras');

            return $codBarras;
        }

        public function getParcel($order_id)
        {
            $parcel = false;
            $order = wc_get_order($order_id);
            $codigo = $order->get_meta('gls_parcel_codigo');
            if (!empty($codigo)) {
                $parcel = array(
                    'codigo' => $order->get_meta( 'gls_parcel_codigo'),
                    'nombre' => $order->get_meta( 'gls_parcel_nombre'),
                    'direccion' => $order->get_meta( 'gls_parcel_direccion'),
                    'cp' => $order->get_meta( 'gls_parcel_cp'),
                    'localidad' => $order->get_meta( 'gls_parcel_localidad'),
                );
            }
            return $parcel;
        }

        public function getReferenciaDst($order_id)
        {
            $res = sprintf('%010d', $order_id);
            return $res;
        }

        public function getServicio($order_id)
        {
            global $wpdb;

            $rs = get_post_meta($order_id, '_shipping_method', true);
            $res = '';
            if (!empty($rs)) {
                foreach ($rs as $r) {
                    $res = $res . $r->meta_value;
                }
            }

            if ($res == '') {
                $sql = " SELECT " . $wpdb->prefix . "woocommerce_order_itemmeta.meta_value FROM " . $wpdb->prefix . "woocommerce_order_itemmeta ";
                $sql .= " INNER JOIN " . $wpdb->prefix . "woocommerce_order_items ON " . $wpdb->prefix . "woocommerce_order_items.order_item_id = " . $wpdb->prefix . "woocommerce_order_itemmeta.order_item_id ";
                $sql .= " WHERE " . $wpdb->prefix . "woocommerce_order_itemmeta.meta_key = 'method_id' and " . $wpdb->prefix . "woocommerce_order_items.order_id = " . $order_id;

                $rs = $wpdb->get_results($sql);
                $res = '';
                foreach ($rs as $r) {
                    $res = $res . $r->meta_value;
                }

            }
			
			$validServices = GLS_Settings::$services;
			if (in_array($res,array_keys($validServices))){
				return $res;
			} else {
				return '';
			}
        }

        public function getObservaciones($order_id)
        {
            global $wpdb;
            //observaciones del usuario
            $sql = "SELECT post_excerpt FROM $wpdb->posts WHERE ID = " . $order_id;

            $rs = $wpdb->get_results($sql);
            $res = '';
            foreach ($rs as $r) {
                $res = $res . $r->post_excerpt . ". ";
            }

            //observaciones desde el backend
            $sql = "SELECT " . $wpdb->prefix . "comments.comment_content FROM " . $wpdb->prefix . "comments ";
            $sql .= "INNER JOIN " . $wpdb->prefix . "commentmeta ON " . $wpdb->prefix . "comments.comment_ID = " . $wpdb->prefix . "commentmeta.comment_id ";
            $sql .= "WHERE " . $wpdb->prefix . "comments.comment_post_ID = " . $order_id . " and " . $wpdb->prefix . "commentmeta.meta_key = 'is_customer_note' ";
            $sql .= "and " . $wpdb->prefix . "commentmeta.meta_value = '1'";

            $rs = $wpdb->get_results($sql);
            //$res = '';
            foreach ($rs as $r) {
                $res = $res . $r->comment_content . ". ";
            }

            return $res;
        }

        /**
         * Get the template url for a file. locate by file existience
         * and then return the corresponding url.
         */
        public function get_template_url($name)
        {
            global $woocommerce;

            $uri = $this->template_default_uri . $name;
            $child_theme_path = get_stylesheet_directory() . '/' . $this->template_path;
            $child_theme_uri = get_stylesheet_directory_uri() . '/' . $this->template_path;
            $theme_path = get_template_directory() . '/' . $this->template_path;
            $theme_uri = get_template_directory_uri() . '/' . $this->template_path;

            if (file_exists($child_theme_path . $name)) {
                $uri = $child_theme_uri . $name;
            } elseif (file_exists($theme_path . $name)) {
                $uri = $theme_uri . $name;
            }

            return $uri;
        }

        /**
         * Load the template file content
         */
        public function get_template($name)
        {
            woocommerce_get_template($name, null, $this->template_path, $this->template_default_path);
        }

        /**
         * Get the current order
         */
        public function get_order()
        {
            return $this->order;
        }

        /**
         * Get the current order items
         */
        public function get_order_items()
        {
            global $woocommerce;
            global $_product;

            $items = $this->order->get_items();
            $data_list = array();

            if (sizeof($items) > 0) {
                foreach ($items as $item) {
                    // Array with data for the printing template
                    $data = array();

                    // Create the product
                    $product = $this->order->get_product_from_item($item);

                    // Set the variation
                    if (isset($item['variation_id']) && $item['variation_id'] > 0) {
                        $data['variation'] = woocommerce_get_formatted_variation($product->get_variation_attributes());
                    } else {
                        $data['variation'] = null;
                    }

                    // Set item meta and replace it when it is empty
                    $meta = new WC_Order_Item_Meta($item['item_meta']);
                    $data['meta'] = $meta->display(false, true);
                    if (empty($data['meta'])) {
                        $data['meta'] = $data['variation'];
                    }

                    // Set item name
                    $data['name'] = $item['name'];

                    // Set item quantity
                    $data['quantity'] = $item['qty'];

                    // Set item download url
                    if ($product->exists() && $product->is_downloadable() && $product->has_file() && ($this->order->get_status() == 'completed' || (get_option('woocommerce_downloads_grant_access_after_payment') == 'yes' && $this->order->status == 'processing'))) {
                        $data['download_url'] = $this->order->get_downloadable_file_url($item['id'], $item['variation_id']);
                    } else {
                        $data['download_url'] = null;
                    }

                    // Set the price
                    $data['price'] = $this->order->get_formatted_line_subtotal($item);

                    // Set the single price
                    $data['single_price'] = $product->get_price();

                    // Set item SKU
                    $data['sku'] = $product->get_sku();

                    // Set item weight
                    $data['weight'] = $product->get_weight();

                    // Set item dimensions
                    $data['dimensions'] = $product->get_dimensions();

                    // Pass complete item array
                    $data['item'] = $item;

                    // Pass complete product object
                    $data['product'] = $product;

                    $data_list[] = $data;
                }
            }

            return $data_list;
        }

        /**
         * Get order custom field
         */
        public function get_order_field($field)
        {
            if (isset($this->get_order()->order_custom_fields[$field])) {
                return $this->get_order()->order_custom_fields[$field][0];
            }
            return;
        }
    }
}
