<?php

class GLS_Settings
{

	public static $wsdl = 'https://www.asmred.com/websrvs/ecm.asmx?wsdl';
	public static $guid = '15F9A8B5-82AC-4094-99F7-9FD58FD43E9E';
	public static $tracking_url = 'https://mygls.gls-spain.es/e/{tracking_number}/{postal_code}/es';
    public static $prefix = 'gls_';
    public static $hidden_submit = 'gls-settings-save';
    public static $form_submitted = 'gls-send-success';
	public static $services = array(
        'gls10' => array(
            'name' => 'GLS - Express10:30 (24 Horas)',
        ),
        'gls14' => array(
            'name' => 'GLS - Express14:00 (24 Horas)',
        ),
        'gls24' => array(
            'name' => 'GLS - Express19:00 (24 Horas)',
        ), 
		'buspar' => array(
            'name' => 'GLS - BusinessParcel (24/48 Horas)',
        ),
        'economy' => array(
            'name' => 'GLS - EconomyParcel (48/72 Horas)',
        ),
        'eurobusinessparcel' => array(
            'name' => 'GLS - Servicio Eurobusiness Parcel',
        ),
        'parcelshopgls' => array(
            'name' => 'GLS - Servicio ParcelShop',
        ),
		'shopdelint' => array(
            'name' => 'GLS - Shop Delivery Internacional',
        ),
    );
	public static $country_codes = array(
		'AD' => 376,
		'AL' => 18093,
		'AT' => 43,
		'BA' => 387,
		'BE' => 32,
		'BG' => 359,
		'CH' => 411,
		'CY' => 301,
		'CZ' => 42,
		'DE' => 49,
		'DK' => 45,
		'EE' => 360,
		'ES' => 34,
		'FI' => 358,
		'FO' => 18125,
		'FR' => 33,
		'GB' => 44,
		'GI' => 441,
		'GR' => 30,
		'HR' => 385,
		'HU' => 36,
		'IE' => 353,
		'IS' => 354,
		'IT' => 39,
		'LT' => 77,
		'LU' => 352,
		'LV' => 78,
		'ME' => 18160,
		'MK' => 389,
		'MT' => 443,
		'NL' => 31,
		'NO' => 47,
		'PL' => 48,
		'PT' => 351,
		'RO' => 40,
		'RS' => 18179,
		'SE' => 46,
		'SI' => 386,
		'SK' => 421,
		'SM' => 391,
		'TR' => 90,
		'VA' => 396
	);

	/**
     * Display settings form
     */
    public static function displaySettings()
    {
		$uri = plugins_url('') . '/woocommerce-gls-envios/';
        /* self::save_settings_page();
		$openCarrier = get_option('gls_opencarrier');
		$validServices = GLS_Settings::$services;
        $path = plugin_dir_path(__DIR__);
        include $path . 'templates/views/settings.php'; */
		
	   ?>
		<div class="wrap gls-config">
			<h1 class="wp-heading-inline"><div class="gls_logo gls_logo_header"><img src="<?=$uri?>images/logo-gls.png"></div><?=esc_html( get_admin_page_title())?></h1>

			<form method="post" action="options.php">
				<?php
				settings_fields('gls_envios_configuration');
				do_settings_sections('gls_envios_configuration');
				?>
				</fieldset>
				<?php
				submit_button('Guardar cambios');
				?>
			</form>
		</div>
		<?php
		
    }
	
	public static function gls_envios_init_options() {
		
		gls_check_options();
		
		register_setting('gls_envios_configuration', 'gls_envios_options');

		add_settings_section(
			'gls_envios_general',
			'',
			function(){
				echo "<fieldset><h2>Configuración General</h2>";
			},
			'gls_envios_configuration'
		);

		add_settings_field(
			'gls_guid',
			'GUID',
			function(){
				$opciones = get_option('gls_envios_options');
				echo "<input type='text' name='gls_envios_options[gls_guid]' value='{$opciones['gls_guid']}' class='regular-text' />";
			},
			'gls_envios_configuration',
			'gls_envios_general'
		);
		
		add_settings_field(
			'gls_wsdl',
			'Webservices URL:',
			function(){
				$opciones = get_option('gls_envios_options');
				echo "<input type='text' name='gls_envios_options[gls_wsdl]' value='{$opciones['gls_wsdl']}' class='regular-text' />
				<p class='description'>URL del servicio web de GLS. Por defecto: https://www.asmred.com/websrvs/ecm.asmx?wsdl</p>";
			},
			'gls_envios_configuration',
			'gls_envios_general'
		);
		
		add_settings_field(
			'gls_total_taxes',
			'Total con impuestos:',
			function(){
	 			$opciones = get_option('gls_envios_options');
				echo "
				<input type='hidden' name='gls_envios_options[gls_total_taxes]' value='0' />
				<input type='checkbox' name='gls_envios_options[gls_total_taxes]' value='1' " . checked($opciones['gls_total_taxes'], 1, false) . " />
				<p class='description'>Marque la casilla si desea que el calculo para la tarificación del total del pedido incluya impuestos.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_general'
		);

		add_settings_field(
			'gls_weight',
			'Peso:',
			function(){
				$opciones = get_option('gls_envios_options');
				echo "<input type='text' name='gls_envios_options[gls_weight]' value='{$opciones['gls_weight']}' class='regular-text' />
				<p class='description'>Si desea que el cálculo del peso del envío se calcule de forma automática en base al sumatorio del peso de los productos que lo conforman según su definición en la base de datos de productos, deje este campo vacío. Si quiere poder modificar el peso de un pedido previo a su envío, defina un peso por defecto (en Kg).</p>";
			},
			'gls_envios_configuration',
			'gls_envios_general'
		);

		add_settings_field(
			'gls_packages_mode',
			'Bultos por envío:',
			function(){
				$opciones = get_option('gls_envios_options');
				if (!isset($opciones['gls_packages_mode'])) $opciones['gls_packages_mode'] = 0;
				echo "<div class='radio'>
					<label>
						<input type='radio' name='gls_envios_options[gls_packages_mode]' value='0' " . checked($opciones['gls_packages_mode'], 0, false) . ">
						Fijo
					</label>
				</div>
				<div class='radio'>
					<label>
						<input type='radio' name='gls_envios_options[gls_packages_mode]' value='1' " . checked($opciones['gls_packages_mode'], 1, false) . ">
						Variable                        
					</label>
				</div>
				
				<p class='description'>Configuración de bultos por envío fijo o variable según numero de artículos.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_general'
		);
		
		add_settings_field(
			'gls_packages',
			'Número de bultos (fijo):',
			function(){
				$opciones = get_option('gls_envios_options');
				echo "<input type='text' name='gls_envios_options[gls_packages]' value='{$opciones['gls_packages']}' class='regular-text' />
				<p class='description'>Indique el número de bultos.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_general'
		);
		
		add_settings_field(
			'gls_items',
			'Número de artículos por bultos (variable):',
			function(){
				$opciones = get_option('gls_envios_options');
				echo "<input type='text' name='gls_envios_options[gls_items]' value='{$opciones['gls_items']}' class='regular-text' />
				<p class='description'>Indique el número de artículos por bulto.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_general'
		);
		
		add_settings_field(
			'gls_return',
			'Retorno:',
			function(){
				$opciones = get_option('gls_envios_options');
				$valores = array(
					'0' => 'Sin retorno',
					'1' => 'Retorno obligatorio',
					'2' => 'Retorno opcional'
				);
				echo "<select name='gls_envios_options[gls_return]'>";
				foreach ($valores as $valor => $label) {
					echo "<option value='$valor' " . selected($opciones['gls_return'], $valor, false) . ">$label</option>";
				}
				echo "</select>";
				echo "<p class='description'>Indique Retorno.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_general'
		);
		
		add_settings_field(
			'gls_rcs',
			'RCS:',
			function(){
	 			$opciones = get_option('gls_envios_options');
				echo "
				<input type='hidden' name='gls_envios_options[gls_rcs]' value='0' />
				<input type='checkbox' name='gls_envios_options[gls_rcs]' value='1' " . checked($opciones['gls_rcs'], 1, false) . " />
				<p class='description'>Indique RCS (Retorno Copia Sellada).</p>";
			},
			'gls_envios_configuration',
			'gls_envios_general'
		);
		
		add_settings_field(
			'gls_origin',
			'Dpto. origen:',
			function(){
				$opciones = get_option('gls_envios_options');
				echo "<input type='text' name='gls_envios_options[gls_origin]' value='{$opciones['gls_origin']}' class='regular-text' />
				<p class='description'>Indique el departamento de origen.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_general'
		);
		
		add_settings_field(
			'gls_insured',
			'Valor asegurado:',
			function(){
				$opciones = get_option('gls_envios_options');
				echo "<input type='text' name='gls_envios_options[gls_insured]' value='{$opciones['gls_insured']}' class='regular-text' />
				<p class='description'>Indique el valor asegurado.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_general'
		);
		
		add_settings_field(
			'gls_incoterm',
			'Retorno:',
			function(){
				$opciones = get_option('gls_envios_options');
				$valores = array(
					'0' => '--',
					'10' => 'Incoterm 10 DDP. COSTES REMITENTE: transporte,despacho,aranceles, impuestos. COSTES DESTINATARIO: no tiene costes',
					'20' => 'Incoterm 20 DAP. COSTES REMITENTE: transporte. COSTES DESTINATARIO: despacho, aranceles e impuestos',
					'30' => 'Incoterm 30 DDP, I.V.A. no pagado . COSTES REMITENTE: transporte,despacho, aranceles. COSTES DESTINATARIO: impuestos',
					'40' => 'Incoterm 40 DAP, despachado. COSTES REMITENTE: transporte, despacho. COSTES DESTINATARIO: aranceles, impuestos',
					'50' => 'Incoterm 50 DDP, bajo valor . COSTES REMITENTE: transporte, despacho. COSTES DESTINATARIO: no tiene costes',
					'18' => 'Incoterm 18 DDP, I.V.A. pre-registrado. Entregado gratis, impuestos pagados, I.V.A. pagado: el remitente paga todos los costos, para los importadores no se producen costos.'
				);
				echo "<select name='gls_envios_options[gls_incoterm]'>";
				foreach ($valores as $valor => $label) {
					echo "<option value='$valor' " . selected($opciones['gls_incoterm'], $valor, false) . ">$label</option>";
				}
				echo "</select>";
				echo "<p class='description'>Incoterm que será usado en caso de envíos destino fuera de la UE con el servicio Eurobusiness Parcel.No tiene efecto para envíos nacionales e internacionales destino UE.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_general'
		);
		
		
		$openCarrier = get_option('gls_opencarrier');
		
		if ($openCarrier) {
			
			add_settings_field(
				'gls_default_service',
				'Servicio por defecto:',
				function(){
					$opciones = get_option('gls_envios_options');
					$validServices = GLS_Settings::$services;
					echo "<select name='gls_envios_options[gls_default_service]'>";
					foreach ($validServices as $valor => $label) {
						echo "<option value='$valor' " . selected($opciones['gls_default_service'], $valor, false) . ">".$label['name']."</option>";
					}
					echo "</select>";
					echo "<p class='description'>Indique servicio por defecto en generación masiva de envíos.</p>";
				},
				'gls_envios_configuration',
				'gls_envios_general'
			);
		}
		
		
		add_settings_section(
			'gls_envios_sender',
			'',
			function(){
				echo "</fieldset><fieldset><h2>Remitente</h2>";
			},
			'gls_envios_configuration'
		);

		add_settings_field(
			'gls_sender_name',
			'Nombre:',
			function(){
				$opciones = get_option('gls_envios_options');
				echo "<input type='text' name='gls_envios_options[gls_sender_name]' value='{$opciones['gls_sender_name']}' class='regular-text' />";
				echo "<p class='description'>Indique el nombre de remitente.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_sender'
		);
		
		add_settings_field(
			'gls_sender_address',
			'Dirección:',
			function(){
				$opciones = get_option('gls_envios_options');
				echo "<input type='text' name='gls_envios_options[gls_sender_address]' value='{$opciones['gls_sender_address']}' class='regular-text' />";
				echo "<p class='description'>Indique la dirección de remitente.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_sender'
		);		
		add_settings_field(
			'gls_sender_postal_code',
			'Código postal:',
			function(){
				$opciones = get_option('gls_envios_options');
				echo "<input type='text' name='gls_envios_options[gls_sender_postal_code]' value='{$opciones['gls_sender_postal_code']}' class='regular-text' />";
				echo "<p class='description'>Indique el código postal de remitente.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_sender'
		);
		
		add_settings_field(
			'gls_sender_city',
			'Población:',
			function(){
				$opciones = get_option('gls_envios_options');
				echo "<input type='text' name='gls_envios_options[gls_sender_city]' value='{$opciones['gls_sender_city']}' class='regular-text' />";
				echo "<p class='description'>Indique la población de remitente.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_sender'
		);
		
		add_settings_field(
			'gls_sender_country',
			'País:',
			function(){
				$opciones = get_option('gls_envios_options');
				$valores = array(
					'ES' => 'España',
					'PT' => 'Portugal'
				);
				echo "<select name='gls_envios_options[gls_sender_country]'>";
				foreach ($valores as $valor => $label) {
					echo "<option value='$valor' " . selected($opciones['gls_sender_country'], $valor, false) . ">$label</option>";
				}
				echo "</select>";
				echo "<p class='description'>Indique el país de remitente.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_sender'
		);
		
		add_settings_section(
			'gls_envios_status',
			'',
			function(){
				echo "</fieldset><fieldset><h2>Estados de pedidos</h2>";
			},
			'gls_envios_configuration'
		);
	
		add_settings_field(
			'gls_order_state_sended_enabled',
			'Habilitar cambio de estado Enviado:',
			function(){
	 			$opciones = get_option('gls_envios_options');
				echo "
				<input type='hidden' name='gls_envios_options[gls_order_state_sended_enabled]' value='0' />
				<input type='checkbox' name='gls_envios_options[gls_order_state_sended_enabled]' value='1' " . checked($opciones['gls_order_state_sended_enabled'], 1, false) . " />";
			},
			'gls_envios_configuration',
			'gls_envios_status'
		);	
		add_settings_field(
			'gls_order_state_sended',
			'Estado Enviado:',
			function(){
				$opciones = get_option('gls_envios_options');
				$statuses = wc_get_order_statuses();
				$valores = array('0'=>'--');
				if (!empty($statuses)) {
					foreach ($statuses as $key => $name) {
						$valores[$key] = $name;
					}
				}
				echo "<select name='gls_envios_options[gls_order_state_sended]'>";
				foreach ($valores as $valor => $label) {
					echo "<option value='$valor' " . selected($opciones['gls_order_state_sended'], $valor, false) . ">$label</option>";
				}
				echo "</select>";
				echo "<p class='description'>Indique el estado de pedido enviado.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_status'
		);
		
		add_settings_field(
			'gls_order_state_delivered_enabled',
			'Habilitar cambio de estado Entregado:',
			function(){
	 			$opciones = get_option('gls_envios_options');
				echo "
				<input type='hidden' name='gls_envios_options[gls_order_state_delivered_enabled]' value='0' />
				<input type='checkbox' name='gls_envios_options[gls_order_state_delivered_enabled]' value='1' " . checked($opciones['gls_order_state_delivered_enabled'], 1, false) . " />";
			},
			'gls_envios_configuration',
			'gls_envios_status'
		);
		add_settings_field(
			'gls_order_state_delivered',
			'Estado Entregado:',
			function(){
				$opciones = get_option('gls_envios_options');
				$statuses = wc_get_order_statuses();
				$valores = array('0'=>'--');
				if (!empty($statuses)) {
					foreach ($statuses as $key => $name) {
						$valores[$key] = $name;
					}
				}
				echo "<select name='gls_envios_options[gls_order_state_delivered]'>";
				foreach ($valores as $valor => $label) {
					echo "<option value='$valor' " . selected($opciones['gls_order_state_delivered'], $valor, false) . ">$label</option>";
				}
				echo "</select>";
				echo "<p class='description'>Indique el estado de pedido entregado.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_status'
		);

		add_settings_field(
			'gls_order_state_in_transit_enabled',
			'Habilitar cambio de estado En tránsito:',
			function(){
	 			$opciones = get_option('gls_envios_options');
				echo "<input type='hidden' name='gls_envios_options[gls_order_state_in_transit_enabled]' value='0' />
					  <input type='checkbox' name='gls_envios_options[gls_order_state_in_transit_enabled]' value='1' " . checked($opciones['gls_order_state_in_transit_enabled'], 1, false) . " />";
			},
			'gls_envios_configuration',
			'gls_envios_status'
		);		
		add_settings_field(
			'gls_order_state_in_transit',
			'Estado En tránsito:',
			function(){
				$opciones = get_option('gls_envios_options');
				$statuses = wc_get_order_statuses();
				$valores = array('0'=>'--');
				if (!empty($statuses)) {
					foreach ($statuses as $key => $name) {
						$valores[$key] = $name;
					}
				}
				echo "<select name='gls_envios_options[gls_order_state_in_transit]'>";
				foreach ($valores as $valor => $label) {
					echo "<option value='$valor' " . selected($opciones['gls_order_state_in_transit'], $valor, false) . ">$label</option>";
				}
				echo "</select>";
				echo "<p class='description'>Indique el estado de pedido en tránsito.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_status'
		);

		
		
		add_settings_section(
			'gls_envios_feedback',
			'',
			function(){
				echo "</fieldset><fieldset><h2>Seguimiento de envío</h2>";
			},
			'gls_envios_configuration'
		);
		
		
		add_settings_field(
			'gls_tracking_note',
			'Notificación al cliente:',
			function(){
	 			$opciones = get_option('gls_envios_options');
				echo "<input type='hidden' name='gls_envios_options[gls_tracking_note]' value='0' />
				<input type='checkbox' name='gls_envios_options[gls_tracking_note]' value='1' " . checked($opciones['gls_tracking_note'], 1, false) . " />
				<p class='description'>Activar envío de email</p>";
			},
			'gls_envios_configuration',
			'gls_envios_feedback'
		);
		add_settings_field(
			'gls_tracking_note_txt',
			'Texto de la notificación al cliente:',
			function(){
				$opciones = get_option('gls_envios_options');
				echo "<textarea name='gls_envios_options[gls_tracking_note_txt]' class='regular-text'>{$opciones['gls_tracking_note_txt']}'</textarea>
				<p class='description'>Puede incluir el código de seguimiento en sus emails personalizados con el código {gls_tracking_note}</p>";
			},
			'gls_envios_configuration',
			'gls_envios_feedback'
		);
		
		
		add_settings_section(
			'gls_envios_print',
			'',
			function(){
				echo "</fieldset><fieldset><h2>Impresión</h2>";
			},
			'gls_envios_configuration'
		);
		
		add_settings_field(
			'gls_tipo_etiqueta',
			'Tipo de etiqueta:',
			function(){
				$opciones = get_option('gls_envios_options');
				$valores = array(
					'PDF' => 'PDF',
					'EPL' => 'EPL'
				);
				echo "<select name='gls_envios_options[gls_tipo_etiqueta]'>";
				foreach ($valores as $valor => $label) {
					echo "<option value='$valor' " . selected($opciones['gls_tipo_etiqueta'], $valor, false) . ">$label</option>";
				}
				echo "</select>";
			},
			'gls_envios_configuration',
			'gls_envios_print'
		);
		
		add_settings_field(
			'gls_apli4',
			'Impresión de etiquetas mútiples en Apli4:',
			function(){
	 			$opciones = get_option('gls_envios_options');
				echo "<input type='hidden' name='gls_envios_options[gls_apli4]' value='0' />
				<input type='checkbox' name='gls_envios_options[gls_apli4]' value='1' " . checked($opciones['gls_apli4'], 1, false) . " />
				<p class='description'>Al seleccionar varios envíos en el listado de envíos GLS y Generar etiquetas se generarán para Apli4.</p>";
			},
			'gls_envios_configuration',
			'gls_envios_print'
		);
		
	}
	

	public static function get_wsdl()
	{
		$opciones = get_option('gls_envios_options');
		$wsdl = $opciones[self::$prefix . 'wsdl'];
		return empty($wsdl) ? self::$wsdl : $wsdl;
	}

	public static function get_guid()
	{
		$opciones = get_option('gls_envios_options');
		$guid = $opciones[self::$prefix . 'guid'];
		
		return empty($guid) ? self::$guid : $guid;
	}

    /**
     * Save all settings
     */
    private static function save_settings_page()
    {		
        if (isset($_POST[self::$hidden_submit]) && wp_verify_nonce($_POST[self::$hidden_submit], self::$form_submitted)) {
            foreach ($_POST as $key => $value) {
                if ($key != self::$hidden_submit && substr($key, 0, strlen(self::$prefix)) == self::$prefix) {
					//$value = str_replace('\"', '"', $value);
                    if (empty($value)) {
                        //delete_option($key);
						update_option($key, false);
                    } else {
                        if (get_option($key) && get_option($key) != $value) {
                            update_option($key, $value);
                        } else {
                            add_option($key, $value);
                        }
                    }
                }
            }
			/* checkbox type */
			$checkbox_type = array(
				self::$prefix . 'rcs',
				self::$prefix . 'apli4',
				self::$prefix . 'order_state_sended_enabled',
				self::$prefix . 'order_state_delivered_enabled',
				self::$prefix . 'order_state_in_transit_enabled',
				self::$prefix . 'gls_tracking_note',
				self::$prefix . 'total_taxes'
			);
			foreach ($checkbox_type as $checkbox) {
				if (!isset($_POST[$checkbox])) {
					//delete_option($checkbox);
					update_option($checkbox, false);
				}
			}
        }
    }

	public static function getOptions($field = null)
	{
		$options = array();
		switch ($field) {
			case 'return':
				return array(
					0 => __('Sin retorno', 'woocommerce-gls-envios'),
					1 => __('Retorno obligatorio', 'woocommerce-gls-envios'),
					2 => __('Retorno opcional', 'woocommerce-gls-envios'),
				);
				break;
			case 'incoterm':
				return array(
					10 => __('Incoterm 10 DDP. COSTES REMITENTE: transporte,despacho,aranceles, impuestos. COSTES DESTINATARIO: no tiene costes', 'woocommerce-gls-envios'),
					20 => __('Incoterm 20 DAP. COSTES REMITENTE: transporte. COSTES DESTINATARIO: despacho, aranceles e impuestos', 'woocommerce-gls-envios'),
					30 => __('Incoterm 30 DDP, I.V.A. no pagado . COSTES REMITENTE: transporte,despacho, aranceles. COSTES DESTINATARIO: impuestos', 'woocommerce-gls-envios'),
					40 => __('Incoterm 40 DAP, despachado. COSTES REMITENTE: transporte, despacho. COSTES DESTINATARIO: aranceles, impuestos', 'woocommerce-gls-envios'),
					50 => __('Incoterm 50 DDP, bajo valor . COSTES REMITENTE: transporte, despacho. COSTES DESTINATARIO: no tiene costes', 'woocommerce-gls-envios'),
					18 => __('Incoterm 18 DDP, I.V.A. pre-registrado. Entregado gratis, impuestos pagados, I.V.A. pagado: el remitente paga todos los costos, para los importadores no se producen costos.', 'woocommerce-gls-envios'),
				);
				break;
			case 'country':
				$country = new WC_Countries();
    			$countries = $country->countries;
				if (!empty($countries)) {
					foreach ($countries as $iso => $name) {
						$options[$iso] = $name;
					}
				}
				return $options;
				break;
			case 'country_origin':
				$options['ES'] = __('España');
				$options['PT'] = __('Portugal');
				return $options;
				break;
			case 'order_statuses':
				$statuses = wc_get_order_statuses();
				if (!empty($statuses)) {
					foreach ($statuses as $key => $name) {
						$options[$key] = $name;
					}
				}
				return $options;
				break;
		}
		return $options;
	}

}

?>
