<?php

/**
 * Writepanel class
 */
if (!class_exists('WooCommerce_Gls_Envios_Writepanel')) {

    class WooCommerce_Gls_Envios_Writepanel
    {

        /**
         * Constructor
         */
        public function __construct()
        {
        }

        /**
         * Load the class
         */
        public function load()
        {
            add_action('admin_init', array($this, 'load_hooks'));
        }

        /**
         * Load the admin hooks
         */
        public function load_hooks()
        {
            //add_action( 'woocommerce_admin_order_actions_end', array( $this, 'add_listing_actions' ) );
            add_action('add_meta_boxes', array($this, 'add_box'));
            //add_action( 'admin_print_scripts', array( $this, 'add_scripts' ) );
            //add_action( 'admin_print_styles', array( $this, 'add_styles' ) );
        }

        /**
         * Add the styles
         */
        public function add_styles()
        {
            if ($this->is_order_edit_page()) {
                wp_enqueue_style('thickbox');
                wp_enqueue_style('woocommerce-gls-envios-styles', WooCommerce_Gls_Envios::$plugin_url . 'css/style.css');
            }
        }

        /**
         * Add the scripts
         */
        public function add_scripts()
        {
            /*
			if( $this->is_order_edit_page() ) {
			$settings = new WooCommerce_Gls_Envios_Settings();

			<script type="text/javascript">
			var show_print_preview = '<?php echo $settings->get_setting( 'show_print_preview' ); ?>';
			</script>
			<?php
			wp_enqueue_script( 'media-upload' );
			wp_enqueue_script( 'thickbox' );

			//Dani
			//wp_enqueue_script( 'woocommerce-gls-envios-scripts', WooCommerce_Gls_Envios::$plugin_url . 'js/script.js', array( 'jquery', 'media-upload', 'thickbox' ) );

			}
         	*/
        }

        /**
         * Is order page
         */
        public function is_order_edit_page()
        {
            global $post_type;
            if ($post_type == 'shop_order') {
                return true;
            } else {
                return false;
            }
        }

        /**
         * Add print actions to the orders listing
         */

        public function add_listing_actions($order)
        {
            //esto sale en la lista de pedidos
            /*
			?>
			<a href="<?php echo wp_nonce_url( admin_url( 'admin-ajax.php?action=generate_gls_envio&template_type=etiqueta&order_id=' . $order->id ), 'generate_gls_envio' ); ?>" class="button tips print-preview-button" target="_blank" alt="<?php esc_attr_e( 'Etiqueta GLS', 'woocommerce-gls-envios' ); ?>" data-tip="<?php esc_attr_e( 'Etiqueta GLS', 'woocommerce-gls-envios' ); ?>">
			<span><?php _e( 'Etiqueta GLS', 'woocommerce-gls-envios' ); ?></span>
			<!--<img src="<?php echo WooCommerce_Gls_Envios::$plugin_url . 'images/print-invoice.png'; ?>" alt="<?php esc_attr_e( 'Etiqueta', 'woocommerce-gls-envios' ); ?>" width="14">-->
			</a>

			<a href="<?php echo wp_nonce_url( admin_url( 'admin-ajax.php?action=generate_gls_envio&template_type=tracking&order_id=' . $order->id ), 'generate_gls_envio' ); ?>" class="button tips print-preview-button" target="_blank" alt="<?php esc_attr_e( 'Tracking GLS', 'woocommerce-gls-envios' ); ?>" data-tip="<?php esc_attr_e( 'Tracking GLS', 'woocommerce-gls-envios' ); ?>">
			<span><?php _e( 'Tracking GLS', 'woocommerce-gls-envios' ); ?></span>
			<!--<img src="<?php echo WooCommerce_Gls_Envios::$plugin_url . 'images/print-delivery-note.png'; ?>" alt="<?php esc_attr_e( 'Tracking', 'woocommerce-gls-envios' ); ?>" width="14"-->
			<?php $sql = "SELECT count(*) as cont FROM wp_postmeta WHERE post_id = " . $order_id . " and meta_key = 'codbarras'"; global $wpdb; $rs = $wpdb->get_results($sql); foreach ($rs as $r) { if($r->cont == 0) echo 'hidden="hidden"'; else echo ''; }?>

			</a>
			<!--<img src="<?php echo admin_url( 'images/wpspin_light.gif' ); ?>" class="loading" alt="">-->
			<?php
         */
        }

        /**
         * Add the meta box on the single order page
         */
        public function add_box()
        { 
			if ( !class_exists( \Automattic\WooCommerce\Internal\DataStores\Orders\CustomOrdersTableController::class ) ){
				$screen = 'shop_order';
			} else {
				$screen = wc_get_container()->get( \Automattic\WooCommerce\Internal\DataStores\Orders\CustomOrdersTableController::class )->custom_orders_table_usage_is_enabled()
					? wc_get_page_screen_id( 'shop-order' )
					: 'shop_order';
			}
            add_meta_box('woocommerce-gls-envios-box', __('GLS', 'woocommerce-gls-envios'), array($this, 'create_box_content'), $screen, 'advanced', 'high');
        }

        /**
         * Create the meta box content on the single order page
         */
        public function create_box_content($order_or_post_id)
        {

            $order = ( $order_or_post_id instanceof WP_Post ) 
				? wc_get_order( $order_or_post_id->ID ) 
				: $order_or_post_id;

			
            if (false == $order) {
                return;
            }
			$post_id = $order->get_ID();
            $order_status = $order->get_status();

            $shippings = $order->get_items('shipping');
			//echo "<pre>".print_r($shippings,true)."</pre>";die;
			$openCarrier = get_option('gls_opencarrier');
			if (empty($shippings) && !$openCarrier) {
                echo '<p>' . __('El método de envío del pedido no corresponde a GLS.', 'woocommerce-gls-envios') . '</p>'; 
				return;
			}
            $glsServices = WC_GLS_Shipping_Method::getServices(true);
			$isGlsShipping = false;
            foreach ($shippings as $shipping) {
                $method_id = $shipping->get_method_id();
				if (in_array($method_id, $glsServices)) $isGlsShipping = true;
            }

            if (!$isGlsShipping && !$openCarrier) {
                echo '<p>' . __('El método de envío del pedido no corresponde a GLS.', 'woocommerce-gls-envios') . ' [' . $method_id . ']' . '</p>';
				return;
			}
			$validServices = GLS_Settings::$services;
			$glsValora = new WC_GLS_Shipping_Method;
			//Dani
            $codbarras = $order->get_meta('codbarras');
            $gen = 0;
            if (!empty($codbarras)) {
                $gen = $codbarras;
                echo '<ul class="woocommerce-gls-envios-actions2"><li>' . __('Pedido ya enviado correctamente a GLS', 'woocommerce-gls-envios') . '</li></ul>';
            }
			if ($gen == 0) {
				if ('processing' == $order_status) {
					$openCarrier = get_option('gls_opencarrier');
					$path = plugin_dir_path(__DIR__);
        			include $path . 'templates/views/box_content.php';
				} else {
					echo '<ul class="woocommerce-gls-envios-actions2"><li>' . __('Revise el estado de su pedido. Lo más probable es que esté pendiente la aprobación de pago.', 'woocommerce-gls-envios') . '</li></ul>';
				}
			} else {
                ?>
                <ul class="woocommerce-delivery-notes-actions2">
                    <li><a href="<?=wp_nonce_url(admin_url('admin-ajax.php?action=generate_gls_envio&template_type=etiqueta&order_id=' . $post_id), 'generate_gls_envio')?>" class="button print-preview-button2" target="_blank" alt="<?=__('Ver etiqueta', 'woocommerce-gls-envios')?>"><?=__('Ver etiqueta', 'woocommerce-gls-envios')?></a></li>
                    <li><a href="<?=wp_nonce_url(admin_url('admin-ajax.php?action=generate_gls_envio&template_type=tracking&order_id=' . $post_id), 'generate_gls_envio')?>" class="button print-preview-button2" target="_blank" alt="<?=__('Seguimiento', 'woocommerce-gls-envios')?>"><?=__('Seguimiento', 'woocommerce-gls-envios')?></a></li>
                </ul>
                <!--<img src="<?=admin_url('images/wpspin_light.gif')?>" class="loading" alt="">-->
                <?php
			}
        }

    }

}

?>