<?php

if (!class_exists('WooCommerce_Gls_Wsdl')) {

    class WooCommerce_Gls_Wsdl {

        protected static $endpoint = 'https://wsclientes.asmred.com/b2b.asmx';
        protected static $valid_states = array('ESTADO', 'INCIDENCIA');

        public static function updateOrderStatuses()
        {
            global $wpdb;

            //$sended = 'wc-' . $order->status == $status_sended;
            //$delivered = 'wc-' . $order->status == $status_delivered;
            //$in_transit = 'wc-' . $order->status == $status_in_transit;
			
			$updateStateDays = get_option('gls_update_state_days');
			if (empty($updateStateDays)) $updateStateDays = 15;
			
            $services = WC_GLS_Shipping_Method::getServices(true);
			$glsOptions = get_option('gls_envios_options');
            $gls_order_state_sended = $glsOptions['gls_order_state_sended'];
			$gls_order_state_in_transit = $glsOptions['gls_order_state_in_transit'];
            $statuses = array($gls_order_state_sended, $gls_order_state_in_transit);
//error_log("\r\n[" . date("r") . "] glsOptions: " . print_r($glsOptions, true), 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
			
			$openCarrier = get_option('gls_opencarrier');
			$glsService = "";
			/* if (!$openCarrier) {
				$glsService = " AND `order_items`.`order_item_type` = 'shipping' 
					AND `order_item_meta`.`meta_key` = 'method_id' 
					AND `order_item_meta`.`meta_value` IN('" . implode("','", $services) . "') ";
			} */
			
            $orders = $wpdb->get_results("
                SELECT `order_items`.`order_id` 
                FROM `{$wpdb->prefix}woocommerce_order_items` AS `order_items` 
                LEFT JOIN `{$wpdb->posts}` AS `posts` ON `order_items`.`order_id` = `posts`.`ID` 
				WHERE `posts`.`post_type` IN ('shop_order','shop_order_placehold')
                ".$glsService."
                AND `posts`.`post_date` BETWEEN (CURDATE() - INTERVAL ".$updateStateDays." DAY ) AND (CURDATE() + INTERVAL 1 DAY) 
                ORDER BY `order_id` DESC"
            );
			$sql = "
                SELECT `order_items`.`order_id` 
                FROM `{$wpdb->prefix}woocommerce_order_items` AS `order_items` 
                LEFT JOIN `{$wpdb->posts}` AS `posts` ON `order_items`.`order_id` = `posts`.`ID` 
				WHERE `posts`.`post_type` IN ('shop_order','shop_order_placehold')
                ".$glsService."
                AND `posts`.`post_date` BETWEEN (CURDATE() - INTERVAL ".$updateStateDays." DAY ) AND (CURDATE() + INTERVAL 1 DAY) 
                ORDER BY `order_id` DESC";
			error_log("\r\n[" . date("r") . "] sql: " . $sql, 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
			error_log("\r\n[" . date("r") . "] orders: " . print_r($orders, true), 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
            if (!empty($orders)) {
                foreach ($orders as $order) {
					$orderObj = wc_get_order($order->order_id);
					$orderStatus = 'wc-'.$orderObj->get_status();
//error_log("\r\n[" . date("r") . "] orderStatus: " . $orderStatus, 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
//error_log("\r\n[" . date("r") . "] statuses: " . print_r($statuses, true), 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
					if (!in_array($orderStatus,$statuses)) {
						continue;
					}
					$last_event = null;
					$barcode = $orderObj->get_meta('codbarras');
//error_log("\r\n[" . date("r") . "] barcode: " . $barcode, 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
                    if (!empty($barcode)) {
                        $data = array(
                            'guid' => GLS_Settings::get_guid(),
                            'shipping_number' => $barcode                       
                        );
                        $xml = self::parseXml('GetExpCli.xml', $data);
                        if (!empty($xml)) { 
                            $resp = self::wsCall(self::$endpoint, $xml);
//error_log("\r\n[" . date("r") . "] Resp: " . print_r($resp, true), 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
                            $xml = simplexml_load_string($resp, null, 0, 'http://www.w3.org/2003/05/soap-envelope');
                            $xml->registerXPathNamespace('asm', 'http://www.asmred.com/');
                            $tracking_events = $xml->xpath("//asm:GetExpCliResult/expediciones/exp/tracking_list/tracking");
							if (!empty($tracking_events)) {
//error_log("\r\n[" . date("r") . "] tracking_events: " . print_r($tracking_events, true), 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
								self::setStateHistory($tracking_events, $order->order_id);
                                foreach ($tracking_events as $event) {
                                    $date = DateTime::createFromFormat('d/m/Y H:i:s', (string)$event->fecha);
                                    $date_last = isset($last_event) ? DateTime::createFromFormat('d/m/Y H:i:s', (string)$last_event->fecha) : null;
                                    if (!$date_last || $date > $date_last) {
                                        $last_event = $event;
                                    }
                                }
                            }
                            if (isset($last_event)) {
                                $orderObj->update_meta_data( 'gls_estado', (string)$last_event->codigo );
								$disableStateUpdate = $glsOptions['gls_disable_state_update'];
                                if (!$disableStateUpdate && ($status = self::parseState($last_event->codigo)) && $status != $order->post_status) {
                                    if (
                                        (
                                            $status == $glsOptions[GLS_Settings::$prefix . 'order_state_sended'] &&
                                            (int)$glsOptions[GLS_Settings::$prefix . 'order_state_sended_enabled'] == 1
                                        ) ||
                                        (
                                            $status == $glsOptions[GLS_Settings::$prefix . 'order_state_delivered'] &&
                                            (int)$glsOptions[GLS_Settings::$prefix . 'order_state_delivered_enabled'] == 1
                                        ) ||
                                        (
                                            $status == $glsOptions[GLS_Settings::$prefix . 'order_state_in_transit'] &&
                                            (int)$glsOptions[GLS_Settings::$prefix . 'order_state_in_transit_enabled'] == 1
                                        )
                                    ) {
                                        $orderObj->update_status($status);
                                    }
                                }
								$orderObj->save();
                            }
                        }
                    }
                }
            }
        }

        public static function getGlsShippingNumber($order_id = null)
        {
            global $wpdb;
            $sql = 'SELECT DISTINCT `meta_value` FROM `' . $wpdb->postmeta . '` WHERE `post_id` = ' . (int)$order_id . ' AND `meta_key` = "codbarras"';
            return $wpdb->get_var($sql);
        }

        public static function parseXml($template = null, $data = array())
        {
            $path = plugin_dir_path(__DIR__);
            //ob_start();
            //include $path . 'templates/xml/' . $template;
            //$xml = ob_get_clean();
            $xml = file_get_contents($path . 'templates/xml/' . $template);
            foreach ($data as $key => $val) {
                $xml = preg_replace('/\{' . $key . '\}/', $val, $xml);
            }
            return $xml;
        }

        public static function parseState($gls_state = null)
        {
            $glsOptions = get_option('gls_envios_options');
            switch ($gls_state) {
                case 2: 
                case 3: 
                case 6: 
                case 9: 
                case 19:
                    return $glsOptions[GLS_Settings::$prefix . 'order_state_in_transit'];
                    break;
                case 7: 
                case 8: 
                    return $glsOptions[GLS_Settings::$prefix . 'order_state_delivered'];
                    break;
                default:
                    return $glsOptions[GLS_Settings::$prefix . 'order_state_sended'];
                    break;
            }  
        }
		
		public static function setStateHistory($tracking_list, $order_id)
		{
			$stateHistory = array();
			foreach($tracking_list as $titem){
				$tipo = (string)$titem->tipo;
				$codigo = (string)$titem->codigo;
				$evento = (string)$titem->evento;
				$date = (string)$titem->fecha;
				if (!in_array($tipo, array('ESTADO', 'INCIDENCIA'))) continue;
				
				$tmpDate = DateTime::createFromFormat('d/m/Y H:i:s', $date);
				$key = $tmpDate->getTimestamp();				

				while (isset($stateHistory[$key])){
					$key +=1;
				}
				$stateHistory[$key]=array(
					'date' => $date,
					'type' => $tipo,
					'code' => $codigo,
					'text' => $evento
				);
			}
			ksort($stateHistory);
			$stateHistory = array_values($stateHistory);
			
			while (count($stateHistory) > 10){
				array_shift($stateHistory);
			}
            $order = wc_get_order($order_id);
            $order->update_meta_data( 'gls_state_history', json_encode($stateHistory) );
            $order->save();
		}

        public static function callPickUp()
        {
            $data = array(
                'guid' => GLS_Settings::get_guid(),                   
            );
            $url = 'https://wsclientes.asmred.com/b2b.asmx';
            $xml = self::parseXml('EnviaCorreoAgencia.xml', $data);
            $resp = self::wsCall($url, $xml);
            update_option(GLS_Settings::$prefix . 'last_pickup', time());
        }

        public static function wsCall($url = null, $xml = null)
        {
            $header = array(
                'Content-Type: text/xml; charset=UTF-8'
            );
            $ch = curl_init();
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($ch, CURLOPT_HEADER, FALSE);
			curl_setopt($ch, CURLOPT_FORBID_REUSE, TRUE);
			curl_setopt($ch, CURLOPT_FRESH_CONNECT, TRUE);
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $xml);
			curl_setopt($ch, CURLOPT_HTTPHEADER, $header);

            if (!$resp = curl_exec($ch)) {
                echo 'Curl error: ' . curl_error($ch);
            }
            
//error_log("\r\n[" . date("r") . "] Resp: " . print_r($resp, true), 3, str_replace('classes', 'log', plugin_dir_path(__FILE__)) . "/".date('Ymd').".log");
			
            return $resp;
        }
    }
}
