
var gls_ajax = {

    pcommon: {
        'ajax': 1,
        'rand': new Date().getTime()
    },

    ajaxCall: function (params, callback) {
        if (typeof params.data != 'undefined') {
            var contentType = false;
            var processData = false;
            var data = params.data;
            delete params.data;
            Object.assign(params, this.pcommon);
            jQuery.each(params, function(index, value) {
                data.append(index, value);
            });
        } else {
            var contentType = 'application/x-www-form-urlencoded; charset=UTF-8';
            var processData = true;
            var data = {};
            Object.assign(data, this.pcommon, params);
        }
        return jQuery.ajax({
            'url': 'admin-ajax.php',
            'method': 'post',
            'dataType': 'json',
            'contentType': contentType,
            'processData': processData,
            'cache': false,
            'data': data,
            'success': function (data) {
                if (typeof callback != 'undefined') {						
                    eval(callback + '(params, data)');
                }
            }
        });
    },
    getRanges: function (params, data) {
        if (typeof data.error != 'undefined') {
            alert(data.error);
			//console.log(data.error);
            jQuery('#zone-range-'+data.zone_id+'-'+data.type+' .ranges').html(data.html);
        } else {
            jQuery('#zone-range-'+data.zone_id+'-'+data.type+' .ranges').html(data.html);
        }
    }
};

function glsAjaxCall(action, params)
{
    var data = {
        action: action
    }
    Object.assign(data, params);
    jQuery.ajax({
        type : 'post',
        url : 'admin-ajax.php',
        data : data,
        error: function(response){
            console.log(response);
        },
        success: function(response) {
            console.log(response);
        }
    });
}

window.addEventListener('load', function() {
    jQuery(document).on('click', '.cost-range-label', function() {
        jQuery('.cost-range-label').addClass('disabled');
        var target = jQuery(this).data('type') == '0' ? 'amount' : 'weight';
        jQuery('.label-' + target).removeClass('disabled');
        jQuery('.gls_amount_block,.gls_weight_block').hide();
        jQuery('.gls_' + target + '_block').css('display','table-row');
    });

    jQuery(document).on('click', '.gls_range_add', function() {
        var type = jQuery(this).data('type');
        var zone_id = jQuery(this).data('zone');
        var role = (jQuery('#gls-role').length)?jQuery('#gls-role').val():'';
        var min = jQuery(this).closest('.input-group').find('.gls_range_min').val();
        var max = jQuery(this).closest('.input-group').find('.gls_range_max').val();
        jQuery(this).closest('.input-group').find('.gls_range_min').val('');
        jQuery(this).closest('.input-group').find('.gls_range_max').val('');
        jQuery('#zone-range-'+zone_id+'-'+type+' .ranges').html('<div id="gls-loading"></div>');
		var params = {
            'action': 'gls_range_add',
            'type': type,
            'zone_id': zone_id,
            'role': role,
            'min': min,
            'max': max
        };
        gls_ajax.ajaxCall(params, 'gls_ajax.getRanges');
    });

    jQuery(document).on('click', '.gls_range_del', function() {
        var type = jQuery(this).data('type');
        var zone_id = jQuery(this).data('zone');
		var role = (jQuery('#gls-role').length)?jQuery('#gls-role').val():'';        var min = jQuery(this).data('min');
        var max = jQuery(this).data('max');
        var message = jQuery(this).data('message');
        var params = {
            'action': 'gls_range_del',
            'type': type,
            'zone_id': zone_id,
            'role': role,
            'min': min,
            'max': max
        };
        if (confirm('Va a eliminar el rango.')) {
	        jQuery('#zone-range-'+zone_id+'-'+type+' .ranges').html('<div id="gls-loading"></div>');
            gls_ajax.ajaxCall(params, 'gls_ajax.getRanges');
        }
    });

    jQuery(document).on('click', '.gls_check', function() {
        var type = jQuery(this).data('type');
        var zone_id = jQuery(this).data('zone');
        var role = jQuery('#gls-role').val();
        var service = jQuery(this).data('service');
        var enabled = jQuery(this).is(':checked') ? 1 : 0;
        var params = {        
            'action': 'gls_check_service',
            'zone_id': zone_id,
            'role': role,
            'service': service,
            'type': type,
            'enabled': enabled
        };
        gls_ajax.ajaxCall(params);
        //console.log(enabled);
		var rtype = (type == 0)? 1 : 0;
		
        if (enabled == 1) {
            jQuery('.gls-' + zone_id + '-' + service + '-' + rtype).attr('disabled', 'disabled');
            jQuery('.cost-input-' + zone_id + '-' + service + '-' + type).removeAttr('disabled');
            jQuery('.cost-input-' + zone_id + '-' + service + '-' + rtype).attr('disabled', 'disabled');
        } else {
            jQuery('.gls-' + zone_id + '-' + service + '-' + rtype).removeAttr('disabled');
            jQuery('.cost-input-' + zone_id + '-' + service + '-' + type).attr('disabled', 'disabled');
            jQuery('.cost-input-' + zone_id + '-' + service + '-' + rtype).removeAttr('disabled');
        }
    });

    jQuery(document).on('keyup', '.cost-input, .gls_range_min, .gls_range_max', function(e) {
		var key = e.which ? e.which : event.keyCode;
        if(key == 110 || key == 188){
          e.preventDefault();
          var value = jQuery(this).val(); 
          console.log(value === "");        
          jQuery(this).val(value.replace(",","."));
        }   
	});
    jQuery(document).on('keyup', '.cost-input', function() {
        /*
        var cost = jQuery(this).val().replace(/,/g, '.');
        var cost = jQuery(this).val().replace(/[^0-9|\.]/g, '');
        var dec = cost.match(/\..+/g);
        if (dec != null && dec[0].length > 3) {
            dec = parseFloat(dec[0].replace(/\./,'')).toFixed(2);
            cost = cost.replace(/\..+/g, '.' + dec);
        }        
        jQuery(this).val(cost);
        */
        var type = jQuery(this).data('type');
        var zone_id = jQuery(this).data('zone');
		var role = (jQuery('#gls-role').length)?jQuery('#gls-role').val():'';        var min = jQuery(this).data('min');
        var service = jQuery(this).data('service');
        var min = jQuery(this).data('min');
        var max = jQuery(this).data('max');
		if (jQuery(this).data('extra')){
			var extra = jQuery(this).val();
			var cost = 'null';
		} else {
			var extra = 'null';
			var cost = jQuery(this).val();
		}
        //var cost =  jQuery(this).val();
        var params = {        
            'action': 'gls_cost_update',
            'type': type,
            'zone_id': zone_id,
            'role': role,
            'service': service,
            'min': min,
            'max': max,
            'extra': extra,
            'cost': cost
        };
        gls_ajax.ajaxCall(params);
    });

    if (typeof(gls_apli4) != 'undefined' && gls_apli4) {
        jQuery('.gls_label_print').each(function(index, obj) {
            var href = jQuery(obj).attr('href');
            jQuery(obj).data('href', href);
            jQuery(obj).removeAttr('target');
            jQuery(obj).attr('href', '#');        
        });
    
        jQuery(document).on('click', '.gls_label_print', function() {
            var href =  jQuery(this).data('href');        
            jQuery('.apli4-popup').data('href', href);
            jQuery('.apli4-popup').show();
            console.log(jQuery('.apli4-popup').data('href'));
        });
    }

    jQuery(document).on('click', '.apli4-label', function() {
        var href = jQuery('.apli4-popup').data('href') + '&section=' + jQuery(this).data('section');
        jQuery('.apli4-popup').hide();
        window.open(href, '_blank').focus();
    });

    jQuery(document).on('click', '.apli4-popup-close', function() {
        jQuery('.apli4-popup').hide();
    });

    jQuery(document).on('click', '.btn-gls-request-pickup', function() {
        var params = {        
            'action': 'call_gls_pickut',
            'send': 'true',
        };
        gls_ajax.ajaxCall(params);
        tb_remove();
    });

    jQuery(document).on('click', '.gls_show_actions', function() {
        if (jQuery(this).parent().find('.gls-form-hidden').is(':visible')) {
            jQuery(this).parent().find('.gls-form-hidden').hide();
        } else {
            jQuery(this).parent().find('.gls-form-hidden').show();
        }
    });

    jQuery(document).on('change', '#gls-role', function() {
        const regex = /&role=(\w+)/gm;
        var role = jQuery(this).val();

        if (role == '') {
            var url = window.location.href.replace(regex, '');
        } else if (regex.exec(window.location.href) !== null) {
            var url = window.location.href.replace(regex, '&role=' + role);
        } else {
            var url = window.location.href + '&role=' + role;
        }
        url = url.replace(/#/g, '');
        if (url != window.location.href) {
            window.location.href = url;
        }
    });
});
